REM ͻ
REM  Program Written in BASIC PDR 7.0  
REM  Program written by Bob McCrossen  
REM ͼ

REM ͻ
REM        PROGRAM TO LOAD AN ALTERNATE EGA ROM CHARACTER SET         
REM                                                                   
REM ͼ

TYPE RegType
	 ax    AS INTEGER
	 bx    AS INTEGER
	 cx    AS INTEGER
	 dx    AS INTEGER
	 bp    AS INTEGER
	 si    AS INTEGER
	 di    AS INTEGER
	 flags AS INTEGER
END TYPE

TYPE RegTypeX
	 ax    AS INTEGER
	 bx    AS INTEGER
	 cx    AS INTEGER
	 dx    AS INTEGER
	 bp    AS INTEGER
	 si    AS INTEGER
	 di    AS INTEGER
	 flags AS INTEGER
	 ds    AS INTEGER
	 es    AS INTEGER
END TYPE
DECLARE SUB Interrupt (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)
DECLARE SUB InterruptX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
DECLARE SUB mouse (m1%, m2%, m3%, m4%)

REM $DYNAMIC
b$ = STRING$(4096, "0")
cmd$ = COMMAND$
IF COMMAND$ = "" THEN
	CLS
	PRINT "Syntax: EGAROM fontfile"
	END
END IF

ON ERROR GOTO filerr
OPEN cmd$ FOR BINARY AS #1
ON ERROR GOTO 0
IF ferr% = 1 THEN
	CLOSE #1
	KILL name$
	BEEP
	CLS
	PRINT "File Not Found!"
	END
END IF

GET #1, , b$
CLOSE #1

ptr% = 0
a$ = ""
lastptr% = 256 * 16
loadstart:
IF ptr% > lastptr% THEN GOTO loadend
a$ = a$ + MID$(b$, ptr% + 1, 14)
ptr% = ptr% + 16
GOTO loadstart
loadend:

DIM regs AS RegTypeX
regs.ax = &H1100
regs.dx = 0                'first character
regs.cx = 256                'number of characters
regs.bx = &HE00             'lines * 256 + chartable
regs.es = SSEG(a$)
regs.bp = SADD(a$)
CALL InterruptX(&H10, regs, regs)
END

filerr:
ferr% = 1
RESUME NEXT

viderr:
ega% = 1
RESUME NEXT

